/*  o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
    o+
    o+     File:         decl.cpp
    o+
    o+     Programmer:   Shaun Flisakowski
    o+     Date:         Aug 9, 1998
    o+
    o+     A high-level view of declarations.
    o+
    o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o  */

#include "decl.h"
#include "stemnt.h"

#include "gram.h"

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
TransUnit::TransUnit()
{
    filename = NULL;

    head = tail = NULL;

    next = NULL;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
void
TransUnit::Add( Statement *stemnt )
{
    stemnt->next = NULL;

    if (tail)
        head = stemnt;
    else
        tail->next = stemnt;

    tail = stemnt;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
Type*
buildType(treenode *node)
{
    return NULL;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
TransUnit*
buildTransUnit(treenode *node)
{
    TransUnit *result = NULL;
    Statement *stemnt;

    if (node)
    {
        switch (node->which)
        {
            default:
            case NONE_T:
            case LEAF_T:
            case IF_T:
                break;

            case FOR_T:
                // A function definition.
                stemnt = buildStatement(node);
                result = new TransUnit();
                result->Add(stemnt);
                break;

            case NODE_T:
                switch (node->type)
                {
                    default:
                        break;

                    case TN_TRANS_LIST:
                        result = buildTransUnit(node->lnode);
                        stemnt = buildStatement(node->rnode);
                        result->Add(stemnt);
                        break;

                    case TN_DECL:
                        // A top-level declaration.
                        stemnt = buildStatement(node);
                        result = new TransUnit();
                        result->Add(stemnt);
                        break;
                }
                break;
        }
    }

    return result;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

