/*  o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
    o+
    o+     File:         decl.h
    o+
    o+     Programmer:   Shaun Flisakowski
    o+     Date:         Aug 9, 1998
    o+
    o+     A high-level view of declarations.
    o+
    o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o  */

#ifndef    DECL_H
#define    DECL_H

#include <stdlib.h>
#include <iostream.h>

#include "tree.h"

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
enum StorageType
{
    ST_Auto=0,
    ST_Register,
    ST_Static,
    ST_Extern
};

enum QualifierType
{
    QT_None=0,
    QT_Const,
    QT_Volatile
};

enum TypeSpecType
{
    TT_Void     = 0,

    TT_Char     = 1,
    TT_Short    = 2,
    TT_Int      = 4,
    TT_Long     = 8,

    TT_Signed   = 16,
    TT_UnSigned = 32,

    TT_Float    = 64,
    TT_Double,

    TT_Struct,
    TT_Union,

    TT_Enum,
    TT_Typedef
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
enum StructType
{
    ST_Struct=0,
    ST_Union
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
enum DeclType
{
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
class Type
{
  public:
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

class Statement;

class TransUnit
{
  public:
    /* List of Statements */
    TransUnit();

    void Add( Statement *stemnt );

    char         *filename;   // The file we parsed this from.

    Statement    *head;       // The first statement in the list.
    Statement    *tail;       // The last statement in the list.

    TransUnit    *next;       // For building a list.
};

class Project
{
  public:
    /* List of TransUnit */
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

Type        *buildType(treenode *node);
TransUnit   *buildTransUnit(treenode *node);

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#endif  /* DECL_H */

